package com.aliyun.odps.spark.examples.myUtils;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.aliyun.odps.Column;
import com.aliyun.odps.data.Record;

import java.util.HashMap;
import java.util.Map;

public class OnlineLogUtils {
    public static Map<String, String> log2Map(Record record, Map<String, String> o2oMap) {
        Map<String, String> map = new HashMap<>();
        if (null != record) {
            Column[] columns = record.getColumns();
            if (null != columns) {
                for (Column column : columns) {
                    String name = column.getName();
                    if (o2oMap.containsKey(name)) {
                        continue;
                    }
                    if (!record.isNull(name)) {
                        if (!name.equals("metafeaturemap")) {
                            map.put(name, record.getString(name));
                        } else {
                            String data = record.getString(name);
                            if (null != data && data.length() > 4) {
                                JSONObject json = JSON.parseObject(data);
                                if (null != json) {
                                    for (Map.Entry<String, String> entry : o2oMap.entrySet()) {
                                        String offKey = entry.getKey();
                                        String onlineKey = entry.getValue();
                                        if (json.containsKey(onlineKey)) {
                                            String value = json.getString(onlineKey);
                                            if (null != value && value.length() > 4) {
                                                map.put(offKey, value);
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        return map;
    }
}
